CREATE TABLE 
ch13.pele_in_kauai(rid serial primary key, 
		twin varchar(30));
SELECT AddRasterColumn('ch13', 'pele_in_kauai', 'rast',26904,
    '{8BUI,8BUI,8BUI,8BUI}',
false, true, '{255,255,255,255}', 10,-10,299,439, null);


UPDATE ch13.pele 
	SET rast = 
		ST_SetBandNoDataValue(ST_SetBandNoDataValue(
			ST_SetBandNoDataValue(
				ST_SetBandNoDataValue(
					rast,1, 255)
				,2,255),
				3,255),4,255) ;




-- Listing 13.1 Getting general summary info about rasters in a kauai table
SELECT count(*) As num_rasters, ST_Height(rast) As height, 
    ST_Width(rast) As width, ST_SRID(rast) As srid,
    ST_NumBands(rast) As num_bands,
    ST_BandPixelType(rast,1) As btype
FROM ch13.kauai
GROUP BY ST_Height(rast) ,
    ST_Width(rast), ST_SRID(rast),
    ST_NumBands(rast),
    ST_BandPixelType(rast,1);

    
-- Listing 13.2 Creating 3 clones of Pele in Kauai
-- 1 create 3 peles across
INSERT INTO ch13.pele_in_kauai(twin, rast)
SELECT 'pele ' || i, 
		ST_SetSRID(
		ST_SetGeoReference(rast, 
		'10 0 0 -10 ' 
	|| 443149.653768 + i  * ST_Width(rast) * 10 
			|| ' ' ||  2440440.99542, 'GDAL'), 
				26904)
	FROM ch13.pele 
	CROSS JOIN generate_series(1,3) As i;
-- 2 correct raster_columns
UPDATE raster_columns 
    SET extent = (SELECT 
			ST_Union(ST_ConvexHull(rast)) 
				FROM ch13.pele_in_Kauai)
WHERE 
		raster_columns.r_table_name = 'pele_in_kauai' 
		and r_table_schema = 'ch13';
-- 3 index and analyze for better performance
CREATE INDEX idx_gist_ch13_pele_in_kauai_rast
   ON ch13.pele_in_kauai USING gist (ST_Envelope(rast));
vacuum analyze ch13.pele_in_kauai;



-- Listing 13.3 upgis_rastertopolygon converting rasters to polygons  is in rutility.sql

-- Listing 13.4 Get the approximate pixel band value at a geometric point is in rutility.sql

-- Listing 13.5 Getting pixel value at a travel point is in travel_functions.sql

-- Listing 13.6 Travel Planner function to minimize on slope and distance is in travel_functions.sql

